// uwaga! trzeba kompilować z opcją -encoding utf-8
import java.math.BigInteger;
import java.io.*;
import java.util.Scanner;
import junit.framework.TestCase;


public class planistaTest extends TestCase {

    private ByteArrayOutputStream outContent;;

    private void setUpStreams(String inp) {
        outContent = new ByteArrayOutputStream();
        System.setOut(new PrintStream(outContent));
        System.setIn(new ByteArrayInputStream(inp.getBytes()));
    }

    private void cleanUpStreams() {
        System.setOut(null);
        System.setIn(null);
    }

    private String runProgram(String inp) {
      return runProgram(inp,null);
    }

    private String runProgram(String inp,String arg) {
        try {
            setUpStreams(inp);
            if (arg==null) {
              Main.main(new String[0]);
            } else {
              String args[]=new String[1];
              args[0]=arg;
              Main.main(args);
            }
            return outContent.toString();
        } finally {
            cleanUpStreams();
        }
    }

    
    public void testNieprawidlowaWatoscN() {
        String inp="TU_POWINNA_BYC_LICZBA\n";
        String output = runProgram(inp);
        assertEquals(output.substring(0,17),"Błąd w wierszu 1:");
    }

    public void testNieprawidlowyPlik() {
        String output = runProgram("","nieznany_plik.txt");
        assertEquals(output.substring(0,18),"Błąd uruchomienia:");
    }

    public void testPrzykładoweDane() {
        String output = runProgram("5\n0 10\n0 29\n0 3\n0 7\n0 12\n2\n1 10\n");
        String lines[] = output.split("\n");
        assertEquals(lines[0],"Strategia: FCFS");
        assertEquals(lines[1],"[1 0 10.00][2 0 39.00][3 0 42.00][4 0 49.00][5 0 61.00]");
        assertEquals(lines[2],"Średni czas obrotu: 40.20");
        assertEquals(lines[3],"Średni czas oczekiwania: 28.00");
        assertEquals(lines[4],"");
        assertEquals(lines[5],"Strategia: SJF");
        assertEquals(lines[6],"[3 0 3.00][4 0 10.00][1 0 20.00][5 0 32.00][2 0 61.00]");
        assertEquals(lines[7],"Średni czas obrotu: 25.20");
        assertEquals(lines[8],"Średni czas oczekiwania: 13.00");
        assertEquals(lines[9],"");
        assertEquals(lines[10],"Strategia: SRT");
        assertEquals(lines[11],"[3 0 3.00][4 0 10.00][1 0 20.00][5 0 32.00][2 0 61.00]");
        assertEquals(lines[12],"Średni czas obrotu: 25.20");
        assertEquals(lines[13],"Średni czas oczekiwania: 13.00");
        assertEquals(lines[14],"");
        assertEquals(lines[15],"Strategia: PS");
        assertEquals(lines[16],"[3 0 15.00][4 0 31.00][1 0 40.00][5 0 44.00][2 0 61.00]");
        assertEquals(lines[17],"Średni czas obrotu: 38.20");
        assertEquals(lines[18],"Średni czas oczekiwania: 0.00");
        assertEquals(lines[19],"");
        assertEquals(lines[20],"Strategia: RR-1");
        assertEquals(lines[21],"[3 0 13.00][4 0 30.00][1 0 38.00][5 0 44.00][2 0 61.00]");
        assertEquals(lines[22],"Średni czas obrotu: 37.20");
        assertEquals(lines[23],"Średni czas oczekiwania: 25.00");
        assertEquals(lines[24],"");
        assertEquals(lines[25],"Strategia: RR-10");
        assertEquals(lines[26],"[1 0 10.00][3 0 23.00][4 0 30.00][5 0 52.00][2 0 61.00]");
        assertEquals(lines[27],"Średni czas obrotu: 35.20");
        assertEquals(lines[28],"Średni czas oczekiwania: 23.00");
        assertTrue(lines.length==29 || lines.length==30);
    }


}
